{-# OPTIONS_GHC -fglasgow-exts #-}

module DepGraph where {

import Show;
import Term;
import Util;
import ErrorMonad;
import Graph;
import Edg;
import List;

checkDepGraphProc ::
  forall a b.
    (Eq a, Sshow a, Eq b,
      Sshow b) => [(Term a b, Term a b)] ->
                    [(Bool, [(Term a b, Term a b)])] ->
                      Maybe (a -> [(Term a b, Term a b)]) ->
                        Maybe (a -> [(Term a b, Term a b)]) ->
                          Eithera [[Char]] ();
checkDepGraphProc p dps rm rrm =
  catcha (checkDecomposition (checkEdgRM rm rrm) p dps)
    (\ x ->
      errora
        (['o', 'u', 'r', ' ', 'e', 's', 't', 'i', 'm', 'a', 't', 'i', 'o', 'n',
           ' ', '(', 'E', 'D', 'G', '*', '*', '*', ')', ' ', 'c', 'o', 'u', 'l',
           'd', ' ', 'n', 'o', 't', ' ', 's', 'h', 'o', 'w', ' ', 't', 'h', 'a',
           't', ' ', 'y', 'o', 'u', ' ', 'g', 'a', 'v', 'e', ' ', 'a', ' ', 'v',
           'a', 'l', 'i', 'd', ' ', 'd', 'e', 'c', 'o', 'm', 'p', 'o', 's', 'i',
           't', 'i', 'o', 'n']
          : x));

}
