{-# OPTIONS_GHC -fglasgow-exts #-}

module Graph where {

import List;
import Util;
import ErrorMonad;
import Show;

check_edge_lazy ::
  forall a. (Eq a) => ((a, a) -> Bool) -> (a, a) -> [(Bool, [a])] -> Bool;
check_edge_lazy g e [] = not (g e);
check_edge_lazy g (x, y) ((real, c) : cs) =
  member x c && (real && member y c || testPos (\ d -> member y (snd d)) cs) ||
    check_edge_lazy g (x, y) cs;

check_edgeM ::
  forall a.
    (Eq a) => ((a, a) -> Bool) -> [(Bool, [a])] -> (a, a) -> Eithera (a, a) ();
check_edgeM g cs e = checkF (\ ea -> check_edge_lazy g ea cs) id e;

checkSccLazy ::
  forall a.
    (Eq a) => ((a, a) -> Bool) -> [a] -> [(Bool, [a])] -> Eithera (a, a) ();
checkSccLazy g ns cs =
  catcha
    (checkAllMI (check_edgeM g cs)
      (concata (mapa (\ x -> mapa (\ a -> (x, a)) ns) ns)))
    (\ x -> errora (snd x));

checkDecomposition ::
  forall a.
    (Eq a,
      Sshow a) => ((a, a) -> Bool) ->
                    [a] -> [(Bool, [a])] -> Eithera [[Char]] ();
checkDecomposition g n allSccs =
  bind (catcha (checkPartition (mapa snd allSccs))
         (\ x ->
           errora
             [append
                ['c', 'o', 'm', 'p', 'o', 'n', 'e', 'n', 't', 's', ' ', 'd',
                  'o', ' ', 'n', 'o', 't', ' ', 'f', 'o', 'r', 'm', ' ', 'a',
                  ' ', 'p', 'a', 'r', 't', 'i', 't', 'i', 'o', 'n', ' ', 'd',
                  'u', 'e', ' ', 't', 'o', ' ', 'n', 'o', 'd', 'e', ' ']
                (sshow x)]))
    (\ x ->
      catcha (checkSccLazy g n allSccs)
        (\ xa ->
          errora
            [['t', 'h', 'e', ' ', 'f', 'o', 'l', 'l', 'o', 'w', 'i', 'n', 'g',
               ' ', 'e', 'd', 'g', 'e', ' ', 'i', 's', ' ', 'n', 'o', 't', ' ',
               'c', 'o', 'v', 'e', 'r', 'e', 'd', ':'],
              sshowa xa]));

}
