{-# OPTIONS_GHC -fglasgow-exts #-}

module DpFramework where {

import Term;
import Option;
import Fun;

computeRuleMap ::
  forall a b.
    (Eq a) => [(Term a b, Term a b)] -> Maybe (a -> [(Term a b, Term a b)]);
computeRuleMap [] = Just (\ f -> []);
computeRuleMap ((Fun f ts, r) : rules) =
  (case computeRuleMap rules of {
    Nothing -> Nothing;
    Just rm -> Just (fun_upd rm f ((Fun f ts, r) : rm f));
  });
computeRuleMap ((Var uu, uv) : rules) = Nothing;

}
